(function(){
	Array.prototype.removeValue = function(name, value){
		var array = $.map(this, function(v,i){
			return v[name] === value ? null : v;
		});
		this.length = 0; //clear original array
		this.push.apply(this, array); //push all elements except the one we want to delete
	}

	var DLC_PRICE = {"dlc1": 0.58338, "dlc2": 0.63, "dlc3": 1.19, "dlc4": 1.75};
	var askDLC = {
		id: "0B90BBED-1999-4CEA-8EE7-A1F39D31B304",
	    isRandomEvent: false,
	    maxTriggers: 99999999999,
	    trigger: function (company) {
	    	var Asked_Game = GDT.getDataStore("DLC_NEW").data.Asked_Game;
	    	if (company.currentGame == undefined)
	    		return false;
	    	var gid = company.currentGame.id;
			if (Asked_Game != gid && company.isGameProgressBetween(.9, 1)) return true;
	    },
	    getNotification: function (company) {
	    	GDT.getDataStore("DLC_NEW").data.Asked_Game = company.currentGame.id;
	        return new Notification({
            	sourceId: "0B90BBED-1999-4CEA-8EE7-A1F39D31B304",
            	header: "Post-Release Content",
            	text: "Your game is about to be released! Would you like to create post-release content for your game? It is a great way of making money, but you may lose some fans if your game doesn't get good enough reviews".localize(),
            	options: ["Yes", "No Thanks"],
            	weeksUntilFired: 0
        	})
        },
	    complete: function (decision) {
	        if (decision === 0) {
	        	gid = GameManager.company.currentGame.id;
	        	var GameList = GDT.getDataStore("DLC_NEW").data.GameList;
		    	if (GameList == undefined)
		    		GameList = {};
		    	
	            Sound.click();
	            GameManager.resume(false);
	            var div = $("#DLCwindow");
	            div.scrollTop()
	            div.gdDialog({
	                popout: !0,
	                close: !0,
	                onClose: function () {
	                    GameList[gid] = {"id": gid, "dlc_unitprice": GDT.getDataStore("DLC_NEW").data.new_unitprice, "lastCheckWeek": 0,"checkCooldown": 0};
		    			GDT.getDataStore("DLC_NEW").data.GameList = GameList;
		    			GDT.getDataStore("DLC_NEW").data.new_unitprice = 0;
	                    GameManager.resume(true);
	                    return;
	                }
	            })
	            return;
	        }
	        if (decision === 1) {
	            return;
	        }
	    }
	};

	var getCash = {
	    id: "8B358EFD-4245-4A5C-98DF-6B7A7A0A42D2",
	    isRandomEvent: false,
	    maxTriggers: 99999999999,
	    trigger: function (company) {
	    	var GameList = GDT.getDataStore("DLC_NEW").data.GameList;
	    	if (GameList == undefined || GameList.length < 1)
	    		return false;
	    	for (var gid in GameList) {
	    		var game = GameList[gid];
	    		var TheGame = company.getGameById(gid);
		    	if (TheGame != null && TheGame.releaseWeek > 0){
		    		var gameReleaseWeek = TheGame.releaseWeek;
			    	var currentWeek = company.currentWeek;
			    	if (currentWeek >= gameReleaseWeek + 48) {
			    		GDT.getDataStore("DLC_NEW").data.Deploying_gid = gid;
			    		GDT.getDataStore("DLC_NEW").data.Deploying_unitprice = game["dlc_unitprice"];
			    		delete GameList[gid];
			    		GDT.getDataStore("DLC_NEW").data.GameList = GameList;
			    		return true;
			    	}
			    	if (game["lastCheckWeek"] === 0) {
			    		checkWeek = Math.ceil(gameReleaseWeek + 0.75) + 4;
			    	}
			    	else {
			    		checkWeek = Math.ceil(game["lastCheckWeek"] + game["checkCooldown"]);
			    	}
					if (currentWeek >= checkWeek) {
						Dice = company.getRandom();
						if (Dice > 0.5) {
							GDT.getDataStore("DLC_NEW").data.Deploying_gid = gid;
			    			GDT.getDataStore("DLC_NEW").data.Deploying_unitprice = game["dlc_unitprice"];
							delete GameList[gid];
				    		GDT.getDataStore("DLC_NEW").data.GameList = GameList;
				    		return true;
						}
						else {
							GameList[gid]["lastCheckWeek"] = currentWeek;
							GameList[gid]["checkCooldown"] = 8 * Dice;
						}
					}
	    		}
	    	}
	    	GDT.getDataStore("DLC_NEW").data.GameList = GameList;
	    },
	    getNotification: function (company) {
	  		var gid = GDT.getDataStore("DLC_NEW").data.Deploying_gid;
	  		var unit_price = GDT.getDataStore("DLC_NEW").data.x;
	  		var TheGame = GameManager.company.getGameById(gid);
	    	var gName = TheGame.title;
	    	var gScore = TheGame.score;
	    	var uSold = TheGame.unitsSold;
			var unit_price = GDT.getDataStore("DLC_NEW").data.Deploying_unitprice;
			var currFans = GameManager.company.fans;
	    	var moneyMade = Math.round(currFans * unit_price);
	    	GDT.getDataStore("DLC_NEW").data.Deploying_unitprice = 0;
	    	GDT.getDataStore("DLC_NEW").data.Deploying_gid = "none";
	    	GameManager.company.adjustCash(moneyMade, "DLC Sales");
	    	var msg = "Post-Release Content";
	    	if (gScore > 8) {
	    		msg = gName + " got a good enough score and your fans bought your content, you made $" + moneyMade + "!";
	    	} else {
	    		var currFans = GameManager.company.fans;
				var adjFans = Math.round(currFans * unit_price * 0.20);
				GameManager.company.adjustFans(-adjFans);
	    		msg = gName + " didn't do so great, so releasing Post-Release Content angered fans more. You made $" + moneyMade + " but lost "+ UI.getShortNumberString(adjFans) + " fans";
	    	}
	        return new Notification({
            	header: "Post-Release Content",
            	text: msg,
            	buttonText: "Okay",
            	weeksUntilFired: 0
        	})
	    }
	};

	GDT.addEvent(askDLC);
	GDT.addEvent(getCash);

//=============================================================================================================================================================
//=============================================================================================================================================================
//=============================================================================================================================================================
//=============================================================================================================================================================

    UI.SellShares = function (a) {
        GDT.getDataStore("DLC_NEW").data.new_unitprice = DLC_PRICE[a.id];
        div.dialog("close");
    };

    var div = $("body");
    div.append('<div id="DLCwindow" class="windowBorder wideWindow" style="overflow:auto;display:none;"> <div id="toDLC" class="windowTitle smallerWindowTitle">Post-Release Content</div>');
    div = $("#DLCwindow"); 
    div.append('<div style="text-align:center;margin-left:50px;width: 675px">What would you like to release as DLC? After your game is released, your DLC will sell based on how many people purchased the game. Watch out though, if your game doesn\'t do well or you release too much DLC, it could hurt your popularity.</div>');
    div.append('<div id="dlc1" class="selectorButton whiteButton" onclick="UI.SellShares(this)" style="margin-left:50px;width: 675px">New Character Textures | Sale Price: $3 | Risk: Low </div>');
    div.append('<div id="dlc2" class="selectorButton whiteButton" onclick="UI.SellShares(this)" style="margin-left:50px;width: 675px">New Items | Sale Price: $5 | Risk: Medium </div>');
	div.append('<div id="dlc3" class="selectorButton whiteButton" onclick="UI.SellShares(this)" style="margin-left:50px;width: 675px">New Maps and Levels | Sale Price: $10 | Risk: High </div>');
	div.append('<div id="dlc4" class="selectorButton whiteButton" onclick="UI.SellShares(this)" style="margin-left:50px;width: 675px">Expansion Pack | Sale Price: $15 | Risk: Very High </div>');

})();